﻿# Créé par Alain, le 05/05/2019 en Python 3.4
#recherche de triplets pythagoriciens primitifs
import math
# calcul de tpp

# borne supérieure de p et q pour z <k
def bsup (k):
    return int(math.sqrt(k))+1

def pgcd(m,n):
    while m%n:
        r=m%n
        m=n
        n=r
    return n

#vérifie si un triplet est pythagoricien
def pythagoricien(t):
    return t[2]*t[2]==t[0]*t[0]+t[1]*t[1]

# vérifie que tous les triplets d'une liste sont pythagoriciens
def tousOK(L):
    for t in L:
        if not(pythagoricien(t)):
            return False
    return True

# postulat de parité différente
def pardif(p,q):
    return p%2 != q%2

#liste des p admissibles pour q donné avec z <k
def possp(q,k):
    return [p for p in range(q,bsup(k)) if p>q and pardif(p,q) and pgcd(p,q)==1]

# donne tous les tpp possibles pour q donné avec z <k
def tppq(q,k):
    S= [[p*p-q*q, 2*p*q,p*p+q*q] for p in possp(q,k) if p*p+q*q<k]
    U=[sorted(t) for t in S]
    return U

# donne tous les tpp possibles pour q donné avec z <k
def tpp(k):
    R=[]
    for q in range (1,bsup(k)):
        R=R+tppq(q,k)
    return R

# fonction principale
def main():
    L = tpp (1000)
    print(L) # liste les résultats
    print(tousOK(L)) #vérifie qu'ils sont tous des tpp

if __name__ == '__main__':
    main()


