#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Sat Nov  2 13:28:38 2019

@author: Jean-Luc
"""

import matplotlib.pyplot as plt
import numpy as np


################################ LECTURE et STOCKAGE DES DONNEES #############################
# le fichier de données doit être situé dans le même dossier que le programme
data = np.genfromtxt('Nuage_de_points.csv',delimiter=';')
# Attention le fichier CSV doit être correctement constuit (séparateur décimal '.' et séparateur de données connu)
# IMPORTANT les données doivent être classées par ordre croissant d'abscisses (pour les graphiques)


x = data[0:,0] #le tableau x va contenir toutes les données de la première colonne du tableau depuis la première ligne
y = data[0:,1] #le tableau x va contenir toutes les données de la deuxième colonne du tableau depuis la première ligne

# AFFICHAGE DES DONNEES "Brutes"

for i in range(len(x)):
    print('x[',i,']= ',x[i],' ; ','y[',i,'] = ',y[i],'\n') #'\n' permet de sauter une ligne dans l'affichage


############################### PARTIE INITIALISATION ############################

x_mod = [0 for i in range(len(x))] #créé un tableau rempli de 0 de la même taille que x
y_mod = [0 for i in range(len(y))] #créé un tableau rempli de 0 de la même taille que y
err_mod = [0 for i in range(len(y))] #crée un tableau rempli de 0 pour contenir les écarts entre les valeurs calculée (modèle) et les données
err_tot = 0 # pour contenir la somme des erreurs entre y et y_mod
carre_err_tot = 0 # pour contenir la somme des carrés des erreurs entre y et y_mod


plt.axis([min(x)-1, max(x)+1, min(y)-1, max(y)+1]) # Définit la fenêtre graphique
plt.scatter(x,y,color='red',marker='+') # trace les points de coordonnées (x,y) : les données réelles
#les options color et marker ne sont pas obligatoirement à renseigner
# pour plus d'informations : http://www.python-simple.com/python-matplotlib/scatterplot.php
plt.show() #fait affihcer le graphique

while True :

    ############################### PARTIE CONSTRUCTION DU MODELE LINEAIRE ############################

    a=float(input('Dans le modèle y=ax+b, quelle valeur de a ? '))
    b=float(input('Dans le modèle y=ax+b, quelle valeur de b ? '))

    for i in range(len(x)):
        x_mod[i]=x[i]
        y_mod[i]=a*x_mod[i]+b #construit un modèle (selon la fonction choisie ici)
        err_mod[i]=y[i]-y_mod[i] #tableau contenant les erreurs entre les données et le modèle
        #print('x[',i,']= ',x[i],' ; ','y[',i,'] = ',y[i],' ; ','y_mod[',i,'] = ',y_mod[i],' ; ','erreur',err_mod[i],'\n') #'\n' permet de sauter une ligne dans l'affichage
        err_tot = err_tot + err_mod[i] #Construction de la somme des erreurs
        carre_err_tot = carre_err_tot + err_mod[i]*err_mod[i] #Construction de la somme du carré des erreurs

    print ('','\n') # Saute une ligne
    print ('* Somme des erreurs : ',err_tot)
    print ('* Somme des carrés des erreurs : ',carre_err_tot)
    print ('    ----- les écarts entre les données réelles et le modèle sont représentées par les segments rouges','\n')
    print ('* Le modèle choisi est de la forme : y = ',a,'x + ',b)
    print ('    ------il est représenté par le segment bleu','\n')

    ############################### PARTIE GRAPHIQUE ############################

    if max(y)>max(y_mod):
        max_y=max(y)
    else :
        max_y=max(y_mod)

    if min(y)<min(y_mod):
        min_y=min(y)
    else :
        min_y=min(y_mod)
    min_x=min(x)
    max_x=max(x)


    plt.scatter(x,y,color='red',marker='+') #trace les points de coordonnées (x,y) : les données
    #les options color et marker ne sont pas obligatoirement à renseigner
    # pour plus d'informations : http://www.python-simple.com/python-matplotlib/scatterplot.php
    plt.scatter(x_mod,y_mod,color='blue',marker='.')
    #trace les points de coordonnées (x_mod,y_mod) : les valeurs calculées à l'aide du modèle

    for i in range(len(x)):
        plt.plot([x[i], x_mod[i]], [y[i],y_mod[i]], 'r-', lw=0.5)
        # trace les segments représentant l'écart entre les données modèlisées et les données réelles

    plt.plot([x_mod[0], x_mod[len(x)-1]], [y_mod[0],y_mod[len(y_mod)-1]], 'b-', lw=0.5)
    # trace le modèle linéaire

    plt.title('Approcher un nuage de points par une droite')
    plt.xlabel('axes des x') # Nom de l'axe des abscisses
    plt.ylabel('axes des y') #Nom de l'axe des ordonnées

    #plt.savefig('ScatterPlot_01.png') #pour conserver une image au format png du graphique
    plt.show()
    S = input('Le résultat vous apparaît-il comme satisfaisant ? (o/n)')
    if S =='o' :
        break # Permet de sortir du programme, et surtout de la boucle While

print ('C ''est fini !!!')